# Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

junction: JUNCTION.DOS JUNCTION.COM JUNCTION.EXE

clean:
	ERASE JUNCTION.DOS JUNCTION.EXP JUNCTION.LIB JUNCTION.OBJ JUNCTION.TMP JUNCTION.W32 JUNCTION.XYZ

clobber: clean
	ERASE JUNCTION.COM JUNCTION.EXE

JUNCTION.LIB:: JUNCTION.TMP
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:NtClose /EXPORT:NtCreateFile /EXPORT:NtFsControlFile /EXPORT:NtSetInformationFile /EXPORT:NtWaitForSingleObject /EXPORT:RtlAllocateHeap /EXPORT:RtlDosPathNameToNtPathName_U_WithStatus /EXPORT:RtlFreeHeap /EXPORT:RtlFreeUnicodeString /EXPORT:RtlSetLastWin32ErrorAndNtStatusFromNtStatus /NAME:NTDLL /NODEFAULTLIB /NOLOGO /OUT:$@ $**

JUNCTION.TMP: JUNCTION.MAK
	CL.EXE /Brepro /c /Fo$@ /Gz /nologo /Tc<< /W4 /wd4100 /X /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/ms648410.aspx

__declspec(dllexport)
long	NtClose(void *_1)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/bb432380.aspx

__declspec(dllexport)
long	NtCreateFile(void *_1, long _2, void *_3, void *_4, void *_5, long _6, long _7, long _8, long _9, void *_10, long _11)
{ return 0; }

__declspec(dllexport)
long	NtFsControlFile(void *_1, void *_2, void *_3, void *_4, void *_5, long _6, void *_7, long _8, void *_9, long _10)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ff557671.aspx

__declspec(dllexport)
long	NtSetInformationFile(void *_1, void *_2, void *_3, long _4, long _5)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ms648412.aspx

__declspec(dllexport)
long	NtWaitForSingleObject(void *_1, long _2, void *_3)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ff552108.aspx

__declspec(dllexport)
void	*RtlAllocateHeap(void *_1, long _2, void *_3)
{ return 0; }

__declspec(dllexport)
long	RtlDosPathNameToNtPathName_U_WithStatus(void *_1, void *_2, void *_3, void *_4)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/mt723417.aspx

__declspec(dllexport)
long	RtlFreeHeap(void *_1, long _2, void *_3)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ms648418.aspx

__declspec(dllexport)
void	RtlFreeUnicodeString(void *_1)
{}

__declspec(dllexport)
void	RtlSetLastWin32ErrorAndNtStatusFromNtStatus(long _1)
{}
<<NOKEEP

JUNCTION.LIB:: JUNCTION.OBJ
	LINK.EXE /LIB /BREPRO /NODEFAULTLIB /NOLOGO /OUT:$@ $@ $**

JUNCTION.OBJ: JUNCTION.MAK
	CL.EXE /analyze /Brepro /c /Fo$@ /GA /GF /Gw /Gy /nologo /Ox /Oy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)
#pragma comment(lib, "junction")
#pragma comment(lib, "kernel32")

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(__movsw)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <winioctl.h>

#define FILE_SHARE_NONE			0UL
#define FILE_CREATE			2UL
#define FILE_DIRECTORY_FILE		1UL
#define FILE_SYNCHRONOUS_IO_NONALERT	32UL

#define IO_REPARSE_TAG_JUNCTION		IO_REPARSE_TAG_MOUNT_POINT

// https://msdn.microsoft.com/en-us/library/ff557749.aspx

#define OBJ_CASE_INSENSITIVE		64UL

#define STATUS_SUCCESS			0L
#define STATUS_FILE_SYSTEM_LIMITATION	0xC0000427L

// https://msdn.microsoft.com/en-us/library/ff552012.aspx

typedef	struct	_REPARSE_DATA_BUFFER
{
	DWORD	ReparseTag;
	WORD	ReparseDataLength;
	WORD	Reserved;
	struct
	{
		WORD	SubstituteNameOffset;
		WORD	SubstituteNameLength;
		WORD	PrintNameOffset;
		WORD	PrintNameLength;
		WCHAR	PathBuffer[sizeof("\\??\\*\0*")];
	} JunctionReparseData;
} REPARSE_DATA_BUFFER;

// https://msdn.microsoft.com/en-us/library/aa380518.aspx

typedef	struct	_UNICODE_STRING
{
	WORD	Length;
	WORD	MaximumLength;
	LPWSTR	Buffer;
} UNICODE_STRING;

// https://msdn.microsoft.com/en-us/library/ff557749.aspx

typedef	struct	_OBJECT_ATTRIBUTES
{
	DWORD		Length;
	HANDLE		RootDirectory;
	UNICODE_STRING	*ObjectName;
	DWORD		Attributes;
	LPVOID		SecurityDescriptor;
	LPVOID		SecurityQualityOfService;
} OBJECT_ATTRIBUTES;

// https://msdn.microsoft.com/en-us/library/ff550671.aspx

typedef	struct	_IO_STATUS_BLOCK
{
	union
	{
		LONG	Status;
		LPVOID	Pointer;
	};
	DWORD_PTR	Information;
} IO_STATUS_BLOCK;

// https://msdn.microsoft.com/en-us/library/ff545765.aspx

typedef	struct	_FILE_DISPOSITION_INFORMATION
{
	BOOLEAN DeleteFile;
} FILE_DISPOSITION_INFORMATION;

typedef	struct	_RTLP_CURDIR_REF
{
	LONG	RefCount;
	HANDLE	Handle;
} RTLP_CURDIR_REF;

typedef	struct	_RTL_RELATIVE_NAME_U
{
	UNICODE_STRING	RelativeName;
	HANDLE		ContainingDirectory;
	RTLP_CURDIR_REF	*CurDirRef;
} RTL_RELATIVE_NAME_U;

// https://msdn.microsoft.com/en-us/library/aa813741.aspx

typedef	struct	_RTL_USER_PROCESS_PARAMETERS
{
	BYTE		Reserved1[16];
	LPVOID		Reserved2[10];
	UNICODE_STRING	ImagePathName;
	UNICODE_STRING	CommandLine;
} RTL_USER_PROCESS_PARAMETERS;

// https://msdn.microsoft.com/en-us/library/aa813708.aspx

typedef	struct	_PEB_LDR_DATA
{
	BYTE		Reserved1[8];
	LPVOID		Reserved2[3];
	LIST_ENTRY	InMemoryOrderModuleList;
} PEB_LDR_DATA;

typedef	VOID	(NTAPI	PS_POST_PROCESS_INIT_ROUTINE) (VOID);

// https://msdn.microsoft.com/en-us/library/aa813706.aspx

typedef	struct	_PEB
{
	BYTE				Reserved1[2];
	BOOLEAN				BeingDebugged;
	BYTE				Reserved2[1];
	LPVOID				Reserved3[2];
	PEB_LDR_DATA			*Ldr;
	RTL_USER_PROCESS_PARAMETERS	*ProcessParameters;
#if 0
	LPVOID				Reserved4[3];
#else
	LPVOID				SubSystemData;
	HANDLE				ProcessHeap;
	RTL_CRITICAL_SECTION		*FastPebLock;
#endif
	LPVOID				AtlThunkSListPtr;
	LPVOID				Reserved5;
	DWORD				Reserved6;
	LPVOID				Reserved7;
	DWORD				Reserved8;
	DWORD				AtlThunkSListPtr32;
	LPVOID				Reserved9[45];
	BYTE				Reserved10[96];
	PS_POST_PROCESS_INIT_ROUTINE	*PostProcessInitRoutine;
	BYTE				Reserved11[128];
	LPVOID				Reserved12[1];
	DWORD				SessionId;
} PEB;

// https://msdn.microsoft.com/en-us/library/ms686708.aspx

typedef	struct	_TEB
{
	LPVOID		Reserved1[12];
	PEB		*ProcessEnvironmentBlock;
	LPVOID		Reserved2[399];
	BYTE		Reserved3[1952];
	LPVOID		TlsSlots[64];
	LIST_ENTRY	TlsLinks;
	LPVOID		Reserved5[26];
	LPVOID		ReservedForOle;
	LPVOID		Reserved6[4];
	LPVOID		*TlsExpansionSlots;
} TEB;

typedef	VOID	(NTAPI	IO_APC_ROUTINE) (VOID            *ApcContext,
			                 IO_STATUS_BLOCK *IoStatusBlock,
			                 DWORD           Reserved);
typedef	LONG	NTSTATUS;

// https://msdn.microsoft.com/en-us/library/ff728840.aspx

typedef	enum	_FILE_INFORMATION_CLASS
{
	FileDispositionInformation = 13
} FILE_INFORMATION_CLASS;

// https://msdn.microsoft.com/en-us/library/ms648410.aspx

__declspec(dllimport)
LONG	NTAPI	NtClose(HANDLE Handle);

// https://msdn.microsoft.com/en-us/library/bb432380.aspx

__declspec(dllimport)
LONG	NTAPI	NtCreateFile(HANDLE            *FileHandle,
		             ACCESS_MASK       DesiredAccess,
		             OBJECT_ATTRIBUTES *ObjectAttributes,
		             IO_STATUS_BLOCK   *IoStatusBlock,
		             LARGE_INTEGER     *AllocationSize,
		             DWORD             FileAttributes,
		             DWORD             ShareAccess,
		             DWORD             CreateDisposition,
		             DWORD             CreateOptions,
		             VOID              *EaBuffer,
		             DWORD             EaLength);
__declspec(dllimport)
LONG	NTAPI	NtFsControlFile(HANDLE          FileHandle,
		                HANDLE          Event,
		                IO_APC_ROUTINE  *ApcRoutine,
		                VOID            *ApcContext,
		                IO_STATUS_BLOCK *IoStatusBlock,
		                DWORD           FsControlCode,
		                VOID            *InputBuffer,
		                DWORD           InputBufferLength,
		                VOID            *OutputBuffer,
		                DWORD           OutputBufferLength);

// https://msdn.microsoft.com/en-us/library/ff567096.aspx

__declspec(dllimport)
LONG	NTAPI	NtSetInformationFile(HANDLE                 FileHandle,
		                     IO_STATUS_BLOCK        *IoStatusBlock,
		                     VOID                   *FileInformation,
		                     DWORD                  FileInformationLength,
		                     FILE_INFORMATION_CLASS FileInformationClass);

// https://msdn.microsoft.com/en-us/library/ms648412.aspx

__declspec(dllimport)
LONG	NTAPI	NtWaitForSingleObject(HANDLE        Handle,
		                      BOOLEAN       Alertable,
		                      LARGE_INTEGER *Timeout);

// https://msdn.microsoft.com/en-us/library/ff552108.aspx

__declspec(dllimport)
LPVOID	NTAPI	RtlAllocateHeap(LPCVOID HeapHandle,
		                DWORD   Flags,
		                SIZE_T  Size);
__declspec(dllimport)
LONG	NTAPI	RtlDosPathNameToNtPathName_U_WithStatus(LPCWSTR             DosName,
		                                        UNICODE_STRING      *NtName,
		                                        LPCWSTR             *PartName,
		                                        RTL_RELATIVE_NAME_U *RelativeName);

// https://msdn.microsoft.com/en-us/library/mt723417.aspx

__declspec(dllimport)
BOOL	NTAPI	RtlFreeHeap(LPCVOID HeapHandle,
		            DWORD   Flags,
		            LPCVOID HeapBase);

// https://msdn.microsoft.com/en-us/library/ms648418.aspx

__declspec(dllimport)
VOID	NTAPI	RtlFreeUnicodeString(UNICODE_STRING *UnicodeString);

__declspec(dllimport)
VOID	NTAPI	RtlSetLastWin32ErrorAndNtStatusFromNtStatus(NTSTATUS Status);

// https://msdn.microsoft.com/en-us/library/ff545765.aspx

const	FILE_DISPOSITION_INFORMATION	fdi = {TRUE};

BOOL	WINAPI	CreateJunctionW(LPCWSTR szJunction, LPCWSTR szTarget)
{
	LPCVOID	lpHeap = NtCurrentTeb()->ProcessEnvironmentBlock->ProcessHeap;
	LONG	ntStatus = STATUS_INVALID_PARAMETER;
	BOOL	bJunction = FALSE;
	HANDLE	hJunction;
	DWORD	dwJunction;

	REPARSE_DATA_BUFFER	*lpJunction;
	IO_STATUS_BLOCK		ioJunction;
	UNICODE_STRING		usJunction, usTarget;
	OBJECT_ATTRIBUTES	oaJunction = {sizeof(oaJunction),
				              (HANDLE) NULL,
				              (UNICODE_STRING *) NULL,
				              OBJ_CASE_INSENSITIVE,
				              NULL,
				              NULL};

	if (szJunction != NULL && *szJunction != L'\0'
	 && szTarget != NULL && *szTarget != L'\0')
	{
		ntStatus = RtlDosPathNameToNtPathName_U_WithStatus(szTarget,
		                                                   &usTarget,
		                                                   (LPCWSTR *) NULL,
		                                                   NULL);
		if (ntStatus == STATUS_SUCCESS)
		{
			dwJunction = sizeof(*lpJunction)
			           - sizeof(L"\\??\\") * 2
			           + usTarget.Length * 2;

			if (dwJunction > MAXIMUM_REPARSE_DATA_BUFFER_SIZE)
				ntStatus = STATUS_FILE_SYSTEM_LIMITATION;
			else
			{
				lpJunction = RtlAllocateHeap(lpHeap, 0UL, dwJunction);

				if (lpJunction == NULL)
					ntStatus = STATUS_NO_MEMORY;
				else
				{
					lpJunction->ReparseTag = IO_REPARSE_TAG_JUNCTION;
					lpJunction->ReparseDataLength = sizeof(lpJunction->JunctionReparseData)
					                              - sizeof(L"\\??\\") * 2
					                              + usTarget.Length *2;
					lpJunction->Reserved = 0;
					lpJunction->JunctionReparseData.SubstituteNameOffset = 0;
					lpJunction->JunctionReparseData.SubstituteNameLength = usTarget.Length;
					lpJunction->JunctionReparseData.PrintNameOffset = usTarget.Length
					                                                + sizeof(L"");
					lpJunction->JunctionReparseData.PrintNameLength = usTarget.Length
					                                                - sizeof(L"\\??\\") + sizeof(L"");

					// https://msdn.microsoft.com/en-us/library/adf7db3x.aspx

					__movsw(lpJunction->JunctionReparseData.PathBuffer,
					        usTarget.Buffer,
					        usTarget.Length / sizeof(L'\0') + 1);
					__movsw(lpJunction->JunctionReparseData.PathBuffer +
					        usTarget.Length / sizeof(L'\0') + 1,
					        usTarget.Buffer + 4,
					        usTarget.Length / sizeof(L'\0') - 3);

					ntStatus = RtlDosPathNameToNtPathName_U_WithStatus(szJunction,
					                                                   &usJunction,
					                                                   (LPCWSTR *) NULL,
					                                                   NULL);
					if (ntStatus == STATUS_SUCCESS)
					{
						oaJunction.ObjectName = &usJunction;

						ntStatus = NtCreateFile(&hJunction,
						                        DELETE | FILE_WRITE_ATTRIBUTES | FILE_WRITE_EA | SYNCHRONIZE,
						                        &oaJunction,
						                        &ioJunction,
						                        (LARGE_INTEGER *) NULL,
						                        FILE_ATTRIBUTE_DIRECTORY,
						                        FILE_SHARE_NONE,
						                        FILE_CREATE,
						                        FILE_DIRECTORY_FILE | FILE_SYNCHRONOUS_IO_NONALERT,
						                        NULL,
						                        0UL);

						if (ntStatus == STATUS_SUCCESS)
						{
							ntStatus = NtFsControlFile(hJunction,
							                           (HANDLE) NULL,
							                           (IO_APC_ROUTINE *) NULL,
							                           NULL,
							                           &ioJunction,
							                           FSCTL_SET_REPARSE_POINT,
							                           lpJunction,
							                           dwJunction,
							                           NULL,
							                           0UL);

							if (ntStatus == STATUS_SUCCESS)
							{
								ntStatus = NtWaitForSingleObject(hJunction,
							                                         FALSE,
							                                         (LARGE_INTEGER *) NULL);
								if (ntStatus == STATUS_SUCCESS)
									ntStatus = ioJunction.Status;
							}

							if (ntStatus == STATUS_SUCCESS)
								bJunction = TRUE;
							else
								NtSetInformationFile(hJunction,
							                             &ioJunction,
								                     &fdi,
								                     sizeof(fdi),
								                     FileDispositionInformation);
							NtClose(hJunction);
						}

						RtlFreeUnicodeString(&usJunction);
					}

					RtlFreeHeap(lpHeap, 0UL, lpJunction);
				}
			}

			RtlFreeUnicodeString(&usTarget);
		}
	}

	if (!bJunction)
		RtlSetLastWin32ErrorAndNtStatusFromNtStatus(ntStatus);

	return bJunction;
}

BOOL	WINAPI	CreateJunctionA(LPCSTR szJunction, LPCSTR szTarget)
{
	// https://msdn.microsoft.com/en-us/library/aa366569.aspx

	HANDLE	hHeap = GetProcessHeap();

	BOOL	bJunction = FALSE;
	UINT	uiJunction, uiTarget;
	LPWSTR	lpJunction, lpTarget;

	if (szJunction == NULL || szJunction[0] == '\0'
	 || szTarget == NULL || szTarget[0] == '\0')

		// https://msdn.microsoft.com/en-us/library/ms680627.aspx

		SetLastError(ERROR_INVALID_PARAMETER);
	else
		if (hHeap != NULL)
		{
			// https://msdn.microsoft.com/en-us/library/ms776413.aspx
			// https://msdn.microsoft.com/en-us/library/dd319072.aspx
			// https://msdn.microsoft.com/en-us/library/ms776446.aspx
			// https://msdn.microsoft.com/en-us/library/dd317756.aspx

			uiJunction = MultiByteToWideChar(CP_ACP,
			                                 MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
			                                 szJunction, -1,
			                                 (LPWSTR) NULL, 0);
			if (uiJunction != 0U)
			{
				uiTarget = MultiByteToWideChar(CP_ACP,
				                               MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
				                               szTarget, -1,
				                               (LPWSTR) NULL, 0);
				if (uiTarget != 0U)
				{
					// https://msdn.microsoft.com/en-us/library/aa366597.aspx

					lpTarget = HeapAlloc(hHeap, 0UL, uiTarget * L'\0');

					if (lpTarget == NULL)
						SetLastError(ERROR_NOT_ENOUGH_MEMORY);
					else
					{
						if (MultiByteToWideChar(CP_ACP,
					                                MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
					                                szTarget, -1,
				        	                        lpTarget, uiTarget) != 0)
						{
							lpJunction = HeapAlloc(hHeap, 0UL, uiJunction * L'\0');

							if (lpJunction == NULL)
								SetLastError(ERROR_NOT_ENOUGH_MEMORY);
							else
							{
								if (MultiByteToWideChar(CP_ACP,
							                                MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
								                        szJunction, -1,
								                        lpJunction, uiJunction) != 0)

									bJunction = CreateJunctionW(lpJunction, lpTarget);

								// https://msdn.microsoft.com/en-us/library/aa366701.aspx

								HeapFree(hHeap, 0UL, lpJunction);
							}
						}

						HeapFree(hHeap, 0UL, lpTarget);
					}
				}
			}
		}

	return bJunction;
}
<<NOKEEP

JUNCTION.W32: JUNCTION.MAK
	CL.EXE /analyze /Brepro /c /Fo$@ /GA /GF /Gw /Gy /nologo /Ox /Oy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)
#pragma comment(lib, "kernel32")

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(__movsw)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <winioctl.h>

#define FILE_SHARE_NONE	0UL

#define IO_REPARSE_TAG_JUNCTION	IO_REPARSE_TAG_MOUNT_POINT

// https://msdn.microsoft.com/en-us/library/ff552012.aspx

typedef	struct	_REPARSE_DATA_BUFFER
{
	DWORD	ReparseTag;
	WORD	ReparseDataLength;
	WORD	Reserved;
	struct
	{
		WORD	SubstituteNameOffset;
		WORD	SubstituteNameLength;
		WORD	PrintNameOffset;
		WORD	PrintNameLength;
		WCHAR	PathBuffer[sizeof("\\??\\*\0*")];
	} JunctionReparseData;
} REPARSE_DATA_BUFFER, *LPREPARSE_DATA_BUFFER;

// https://msdn.microsoft.com/en-us/library/aa364221.aspx

const	FILE_DISPOSITION_INFO	fdi = {TRUE};

BOOL	WINAPI	CreateJunctionW(LPCWSTR szJunction, LPCWSTR szTarget)
{
	LPREPARSE_DATA_BUFFER	lpJunction;

	BOOL	bJunction = FALSE;
	HANDLE	hJunction;
	DWORD	dwJunction;
	DWORD	dwTarget;

	if (szJunction == NULL || szJunction[0] == L'\0'
	 || szTarget == NULL || szTarget[0] == L'\0'
	 || (szTarget[0] == L'\\' || szTarget[0] == L'/')
	 && (szTarget[1] == L'\\' || szTarget[1] == L'/'))

		// https://msdn.microsoft.com/en-us/library/ms680627.aspx

		SetLastError(ERROR_INVALID_PARAMETER);
	else
	{	// CAVEAT: GetFullPathName() returns buffer size greater than
		//          string length + 1 for path name with "." or ".."!

		// https://msdn.microsoft.com/en-us/library/aa364963.aspx

		dwTarget = GetFullPathNameW(szTarget, 0UL, (LPWSTR) NULL, (LPWSTR *) NULL);

		if (dwTarget != 0UL)
		{
			dwJunction = sizeof(*lpJunction)
			           - sizeof(L'\0') * 4
			           + sizeof(L'\0') * 2 * dwTarget;

			// https://msdn.microsoft.com/en-us/library/aa366723.aspx

			lpJunction = LocalAlloc(NONZEROLPTR, dwJunction);

			if (lpJunction != NULL)
			{
				// https://msdn.microsoft.com/en-us/library/aa364963.aspx

				dwTarget = GetFullPathNameW(szTarget,
				                            dwTarget,
				                            lpJunction->JunctionReparseData.PathBuffer + 4,
				                            (LPWSTR *) NULL);
				if (dwTarget != 0UL)
				{
					dwJunction = sizeof(*lpJunction)
					           - sizeof(L'\0') * 2
					           + sizeof(L'\0') * 2 * dwTarget;

					if (dwJunction > MAXIMUM_REPARSE_DATA_BUFFER_SIZE)
						SetLastError(ERROR_FILE_SYSTEM_LIMITATION);
					else
					{
						lpJunction->ReparseTag = IO_REPARSE_TAG_JUNCTION;
						lpJunction->ReparseDataLength = sizeof(lpJunction->JunctionReparseData)
						                              - sizeof(L'\0') * 2
						                              + sizeof(L'\0') * 2 * dwTarget;
						lpJunction->Reserved = 0;
						lpJunction->JunctionReparseData.SubstituteNameOffset = 0;
						lpJunction->JunctionReparseData.SubstituteNameLength = sizeof(L'\0') * dwTarget
						                                                     + sizeof(L'\0') * 4;
						lpJunction->JunctionReparseData.PrintNameOffset = sizeof(L'\0') * dwTarget
						                                                + sizeof(L'\0') * 5;
						lpJunction->JunctionReparseData.PrintNameLength = sizeof(L'\0') * dwTarget;
						lpJunction->JunctionReparseData.PathBuffer[0] = L'\\';
						lpJunction->JunctionReparseData.PathBuffer[1] = L'?';
						lpJunction->JunctionReparseData.PathBuffer[2] = L'?';
						lpJunction->JunctionReparseData.PathBuffer[3] = L'\\';

						// https://msdn.microsoft.com/en-us/library/adf7db3x.aspx

						__movsw(lpJunction->JunctionReparseData.PathBuffer + 4 + dwTarget + 1,
						        lpJunction->JunctionReparseData.PathBuffer + 4, dwTarget + 1);

						// https://msdn.microsoft.com/en-us/library/aa363858.aspx

						hJunction = CreateFileW(szJunction,
						                        DELETE | FILE_WRITE_ATTRIBUTES | FILE_WRITE_EA,
						                        FILE_SHARE_NONE,
						                        (LPSECURITY_ATTRIBUTES) NULL,
						                        CREATE_NEW,
						                        FILE_ATTRIBUTE_DIRECTORY | FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_POSIX_SEMANTICS,
						                        (HANDLE) NULL);

						if (hJunction != INVALID_HANDLE_VALUE)
						{
							// https://msdn.microsoft.com/en-us/library/aa363216.aspx
							// https://msdn.microsoft.com/en-us/library/aa364595.aspx

							bJunction = DeviceIoControl(hJunction,
							                            FSCTL_SET_REPARSE_POINT,
							                            lpJunction,
							                            dwJunction,
							                            NULL,
							                            0UL,
							                            &dwJunction,
							                            (LPOVERLAPPED) NULL);
							if (bJunction == FALSE)

								// https://msdn.microsoft.com/en-us/library/aa365539.aspx
								// https://msdn.microsoft.com/en-us/library/aa364228.aspx

								SetFileInformationByHandle(hJunction,
								                           FileDispositionInfo,
								                           &fdi,
								                           sizeof(fdi));

							// https://msdn.microsoft.com/en-us/library/ms724211.aspx

							CloseHandle(hJunction);
						}
					}
				}

				// https://msdn.microsoft.com/en-us/library/aa366730.aspx

				LocalFree(lpJunction);
			}
		}
	}

	return bJunction;
}

BOOL	WINAPI	CreateJunctionA(LPCSTR szJunction, LPCSTR szTarget)
{
	LPREPARSE_DATA_BUFFER	lpJunction;

	BOOL	bJunction = FALSE;
	HANDLE	hJunction;
	DWORD	dwJunction;
	DWORD	dwTarget;
	LPSTR	lpTarget;

	if (szJunction == NULL || szJunction[0] == '\0'
	 || szTarget == NULL || szTarget[0] == '\0'
	 || (szTarget[0] == '\\' || szTarget[0] == '/')
	 && (szTarget[1] == '\\' || szTarget[1] == '/'))

		// https://msdn.microsoft.com/en-us/library/ms680627.aspx

		SetLastError(ERROR_INVALID_PARAMETER);
	else
	{	// CAVEAT: GetFullPathName() returns buffer size greater than
		//          string length + 1 for path name with "." or ".."!

		// https://msdn.microsoft.com/en-us/library/aa364963.aspx

		dwTarget = GetFullPathNameA(szTarget, 0UL, (LPSTR) NULL, (LPSTR *) NULL);

		if (dwTarget != 0UL)
		{
			// https://msdn.microsoft.com/en-us/library/aa366723.aspx

			lpTarget = LocalAlloc(NONZEROLPTR, dwTarget);

			if (lpTarget != NULL)
			{
				// https://msdn.microsoft.com/en-us/library/aa364963.aspx

				dwTarget = GetFullPathNameA(szTarget, dwTarget, lpTarget, (LPSTR *) NULL);

				if (dwTarget != 0UL)
				{
					// https://msdn.microsoft.com/en-us/library/ms776413.aspx
					// https://msdn.microsoft.com/en-us/library/dd319072.aspx
					// https://msdn.microsoft.com/en-us/library/ms776446.aspx
					// https://msdn.microsoft.com/en-us/library/dd317756.aspx

					dwTarget = MultiByteToWideChar(CP_ACP,
					                               MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
					                               lpTarget, -1,
					                               (LPWSTR) NULL, 0);
					if (dwTarget != 0UL)
					{
						dwJunction = sizeof(*lpJunction)
						           - sizeof(L'\0') * 4
						           + sizeof(L'\0') * 2 * dwTarget;

						if (dwJunction > MAXIMUM_REPARSE_DATA_BUFFER_SIZE)
							SetLastError(ERROR_FILE_SYSTEM_LIMITATION);
						else
						{	// https://msdn.microsoft.com/en-us/library/aa366723.aspx

							lpJunction = LocalAlloc(NONZEROLPTR, dwJunction);

							if (lpJunction != NULL)
							{
								// https://msdn.microsoft.com/en-us/library/ms776413.aspx
								// https://msdn.microsoft.com/en-us/library/dd319072.aspx
								// https://msdn.microsoft.com/en-us/library/ms776446.aspx
								// https://msdn.microsoft.com/en-us/library/dd317756.aspx

								dwTarget = MultiByteToWideChar(CP_ACP,
								                               MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
								                               lpTarget, -1,
								                               lpJunction->JunctionReparseData.PathBuffer + 4,
								                               dwTarget);
								if (dwTarget != 0UL)
								{
									lpJunction->ReparseTag = IO_REPARSE_TAG_JUNCTION;
									lpJunction->ReparseDataLength = sizeof(lpJunction->JunctionReparseData)
									                              - sizeof(L'\0') * 4
									                              + sizeof(L'\0') * 2 * dwTarget;
									lpJunction->Reserved = 0;
									lpJunction->JunctionReparseData.SubstituteNameOffset = 0;
									lpJunction->JunctionReparseData.SubstituteNameLength = sizeof(L'\0') * dwTarget
									                                                     + sizeof(L'\0') * 3;
									lpJunction->JunctionReparseData.PrintNameOffset = sizeof(L'\0') * dwTarget
									                                                + sizeof(L'\0') * 4;
									lpJunction->JunctionReparseData.PrintNameLength = sizeof(L'\0') * dwTarget
									                                                - sizeof(L'\0');
									lpJunction->JunctionReparseData.PathBuffer[0] = L'\\';
									lpJunction->JunctionReparseData.PathBuffer[1] = L'?';
									lpJunction->JunctionReparseData.PathBuffer[2] = L'?';
									lpJunction->JunctionReparseData.PathBuffer[3] = L'\\';

									// https://msdn.microsoft.com/en-us/library/adf7db3x.aspx

									__movsw(lpJunction->JunctionReparseData.PathBuffer + 4 + dwTarget,
									        lpJunction->JunctionReparseData.PathBuffer + 4, dwTarget);

									// https://msdn.microsoft.com/en-us/library/aa363858.aspx

									hJunction = CreateFileA(szJunction,
									                        DELETE | FILE_WRITE_ATTRIBUTES | FILE_WRITE_EA,
									                        FILE_SHARE_NONE,
									                        (LPSECURITY_ATTRIBUTES) NULL,
									                        CREATE_NEW,
									                        FILE_ATTRIBUTE_DIRECTORY | FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_POSIX_SEMANTICS,
									                        (HANDLE) NULL);

									if (hJunction != INVALID_HANDLE_VALUE)
									{
										// https://msdn.microsoft.com/en-us/library/aa363216.aspx
										// https://msdn.microsoft.com/en-us/library/aa364595.aspx

										bJunction = DeviceIoControl(hJunction,
										                            FSCTL_SET_REPARSE_POINT,
										                            lpJunction,
										                            dwJunction,
										                            NULL,
										                            0UL,
										                            &dwJunction,
										                            (LPOVERLAPPED) NULL);
										if (bJunction == FALSE)

											// https://msdn.microsoft.com/en-us/library/aa365539.aspx
											// https://msdn.microsoft.com/en-us/library/aa364228.aspx

											SetFileInformationByHandle(hJunction,
											                           FileDispositionInfo,
											                           &fdi,
											                           sizeof(fdi));

										// https://msdn.microsoft.com/en-us/library/ms724211.aspx

										CloseHandle(hJunction);
									}
								}

								// https://msdn.microsoft.com/en-us/library/aa366730.aspx

								LocalFree(lpJunction);
							}
						}
					}
				}

				// https://msdn.microsoft.com/en-us/library/aa366730.aspx

				LocalFree(lpTarget);
			}
		}
	}

	return bJunction;
}
<<NOKEEP

JUNCTION.COM: JUNCTION.XYZ JUNCTION.LIB # JUNCTION.DOS
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:kernel32 /EMITTOOLVERSIONINFO:NO /ENTRY:mainCRTStartup /FIXED /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:ICF,REF /OSVERSION:5.0 /OUT:$@ /RELEASE /STUB:JUNCTION.DOS /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /VERSION:0.815 $**

JUNCTION.EXE: JUNCTION.XYZ JUNCTION.LIB # JUNCTION.DOS
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:kernel32 /EMITTOOLVERSIONINFO:NO /ENTRY:wmainCRTStartup /FIXED /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:ICF,REF /OSVERSION:5.0 /OUT:$@ /RELEASE /STUB:JUNCTION.DOS /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /VERSION:0.815 $**

JUNCTION.XYZ: JUNCTION.MAK
	CL.EXE /Brepro /c /Fo$@ /GA /GF /Gy /nologo /Ox /Oy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

BOOL	WINAPI	CreateJunctionA(LPCSTR szJunction, LPCSTR szTarget);
BOOL	WINAPI	CreateJunctionW(LPCWSTR szJunction, LPCWSTR szTarget);

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	CDECL	mainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms682658.aspx
	// https://msdn.microsoft.com/en-us/library/ms679360.aspx

	ExitProcess(CreateJunctionA("Junction", "..") ? ERROR_SUCCESS : GetLastError());
}

__declspec(noreturn)
VOID	CDECL	wmainCRTStartup(VOID)
{
	ExitProcess(CreateJunctionW(L"Junction", L"..") ? ERROR_SUCCESS : GetLastError());
}
<<NOKEEP

JUNCTION.OMF: JUNCTION.MAK
	ML.EXE /Brepro /Fo$@ /nologo /omf /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	tiny

; https://support.microsoft.com/en-us/kb/65122

e_header struct				; DOS .EXE header
e_magic	word	5A4Dh			; magic number "MZ"
e_cblp	word	stop - header		; bytes on last page of file
e_cp	word	1			; pages in file
e_crlc	word	0			; number of relocation table entries
e_cparhdr word	sizeof header / 16	; size of header in paragraphs
e_minalloc word	0			; minimum extra paragraphs needed
e_maxalloc word	65535			; maximum extra paragraphs needed
e_ss	word	0			; initial (PSP relative) SS value
e_sp	word	stack - header		; initial (SS relative) SP value
e_csum	word	0			; checksum
e_ip	word	sizeof message		; initial (CS relative) IP value
e_cs	word	0			; initial (PSP relative) CS value
e_lfarlc word	sizeof header		; file address of relocation table
e_ovno	word	0			; overlay number
e_res	word	4 dup (0)		; reserved words
e_oemid	word	5719h			; OEM identifier
e_oeminfo word	2704h			; OEM information
e_res2	word	10 dup (0)		; reserved words
e_lfanew dword	0			; file address of new exe header
e_header ends

	.code

header	e_header <>

message	byte	"(C)opyright 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>", 0Dh, 0Ah, 07h, 24h

start:
	push	cs
	pop	ds
	xor	dx, dx
	mov	ah, 09h
	int	21h

	mov	ax, 4C01h
	int	21h
stop:
	dword	20 dup (?)
stack:
	end	start
<<NOKEEP

JUNCTION.DOS: JUNCTION.MAK
	CERTUTIL.EXE /DecodeHex /F /V << $@
4D 5A 90 00 01 00 00 00 04 00 00 00 FF FF 00 00   MZ..............
E0 00 00 00 43 00 00 00 40 00 00 00 00 00 00 00   ....C...@.......
00 00 00 00 19 57 04 27 00 00 00 00 00 00 00 00   .....W.'........
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ................
28 43 29 6F 70 79 72 69 67 68 74 20 32 30 30 34   (C)opyright 2004
2D 32 30 32 35 2C 20 53 74 65 66 61 6E 20 4B 61   -2025, Stefan Ka
6E 74 68 61 6B 20 3C 73 74 65 66 61 6E 2E 6B 61   nthak <stefan.ka
6E 74 68 61 6B 40 6E 65 78 67 6F 2E 64 65 3E 0D   nthak@nexgo.de>.
0A 07 24 0E 1F 33 D2 B4 09 CD 21 B8 01 4C CD 21   .....3....!..L.!
<<NOKEEP
